<?php

namespace FiloBlu\KlarnaOnsiteMessaging\Block\Widget;

class Base extends \Magento\Framework\View\Element\Template implements \Magento\Widget\Block\BlockInterface {

    protected $_helper;
	protected $_registry;
	protected $_scopeConfig;
	protected $_store;
	protected $_template = "base-widget.phtml";

	public function __construct(
        \FiloBlu\KlarnaOnsiteMessaging\Helper\Data $helper,
		\Magento\Framework\App\Config\ScopeConfigInterface $scopeConfig,
		\Magento\Framework\Locale\Resolver $store,
        \Magento\Framework\Registry $registry,
        \Magento\Framework\View\Element\Template\Context $context,
		array $data = []
	) {
        $this->_helper = $helper;
		$this->_registry = $registry;
		$this->_scopeConfig = $scopeConfig;
		$this->_store = $store;
		parent::__construct($context, $data);
	}

	public function getDefaultCountryByWebsite() {
		return $this->_scopeConfig->getValue("general/country/default", \Magento\Store\Model\ScopeInterface::SCOPE_STORE);
    }

	public function getFinalPrice() {
		if ($this->_registry->registry("current_product")) {
			return str_replace([",", "."], "", strval($this->_registry->registry("current_product")->getFinalPrice()));
		}

		return null;
	}

	public function isActive() {
		return $this->_helper->getConfig("onsite_messaging/active");
	}

	public function isActiveOnCart() {
		return $this->isActive() && $this->_helper->getConfig("onsite_messaging/active_on_cart");
	}

	public function isActiveOnProductPage() {
		return $this->isActive() && $this->_helper->getConfig("onsite_messaging/active_on_product");
	}

	public function getLocale() {
		return explode("_", $this->_store->getLocale())[0] . "-" . $this->getDefaultCountryByWebsite();
	}

}
